/* ***** BEGIN LICENSE BLOCK *****
 * Version: GPL 3.0
 *
 * The contents of this file are subject to the General Public License
 * 3.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.gnu.org/licenses/gpl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * -- Exchange 2007/2010 Calendar and Tasks Provider.
 * -- For Thunderbird with the Lightning add-on.
 *
 * This work is a combination of the Storage calendar, part of the default Lightning add-on, and 
 * the "Exchange Data Provider for Lightning" add-on currently, october 2011, maintained by Simon Schubert.
 * Primarily made because the "Exchange Data Provider for Lightning" add-on is a continuation 
 * of old code and this one is build up from the ground. It still uses some parts from the 
 * "Exchange Data Provider for Lightning" project.
 *
 * Author: Michel Verbraak (info@1st-setup.nl)
 * Website: http://www.1st-setup.nl/wordpress/?page_id=133
 * email: exchangecalendar@extensions.1st-setup.nl
 *
 *
 * This code uses parts of the Microsoft Exchange Calendar Provider code on which the
 * "Exchange Data Provider for Lightning" was based.
 * The Initial Developer of the Microsoft Exchange Calendar Provider Code is
 *   Andrea Bittau <a.bittau@cs.ucl.ac.uk>, University College London
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * ***** BEGIN LICENSE BLOCK *****/
var Cu = Components.utils;

Cu.import("resource://exchangecalendar/ecFunctions.js");
Cu.import("resource://calendar/modules/calUtils.jsm");

function exchWebServicesDisableItemAndChildren(aItem)
{
	if (!aItem) {
		return;
	}

	try {
		if (aItem.localName != "label") {
			aItem.disabled = true;
		}
	}
	catch(err) {
		// We do not mind any errors.
	}

	// See if we have children. If so process them
	if (aItem.hasChildNodes()) {
		var children = aItem.childNodes;
		for (var i=0; i<children.length; i++) {
			exchWebServicesDisableItemAndChildren(children[i]);
		}
	}
}

function exchWebServicesEnableItemAndChildren(aItem)
{
	if (!aItem) {
		return;
	}

	try {
		if (aItem.localName != "label") {
			aItem.disabled = false;
		}
	}
	catch(err) {
		// We do not mind any errors.
	}

	// See if we have children. If so process them
	if (aItem.hasChildNodes()) {
		var children = aItem.childNodes;
		for (var i=0; i<children.length; i++) {
			exchWebServicesEnableItemAndChildren(children[i]);
		}
	}
}

function exchWebServicesEventDialogLoad(event) {

	// nuke the onload, or we get called every time there's
	// any load that occurs
	document.removeEventListener("load", exchWebServicesEventDialogLoad, false);

	// This is old code/ Will be replaced by the new Attachment code.
	var args = window.arguments[0];
	var item = args.calendarEvent;
	ews.LOG("  -- onLoad ("+ews.STACKshort()+")");
	if (cal.isEvent(item)) {
		ews.LOG("  -- It is a Calendar event ("+ews.STACKshort()+")");
		if ((item.calendar) && (item.calendar.type == "exchangecalendar")) {
			ews.LOG("  -- It is an Exchange Calendar event ("+ews.STACKshort()+")");
			// It is an Exchange calendar item. We are going to see if it is an invitation.
			if ((item.getProperty("X-IsInvitation")) && (item.getProperty("X-IsInvitation") == "true")) {
				ews.LOG("  -- It is an Exchange Invitation ("+ews.STACKshort()+")");
				// It is an invitation. We are going to disable a lot of fields.
				var grid = document.getElementById("event-grid-rows");
				exchWebServicesDisableItemAndChildren(grid);

				exchWebServicesDisableItemAndChildren(document.getElementById("button-attendees"));
				exchWebServicesDisableItemAndChildren(document.getElementById("button-url"));
				exchWebServicesDisableItemAndChildren(document.getElementById("attendee-popup-invite-menuitem"));

				exchWebServicesDisableItemAndChildren(document.getElementById("options-attendess-menuitem"));
				exchWebServicesDisableItemAndChildren(document.getElementById("options-attachments-menuitem"));
				exchWebServicesDisableItemAndChildren(document.getElementById("options-timezone-menuitem"));

				// Enable the right fields
				exchWebServicesEnableItemAndChildren(document.getElementById("item-alarm"));
				exchWebServicesEnableItemAndChildren(document.getElementById("item-categories"));
			}
		}
	}

}

document.addEventListener("load", exchWebServicesEventDialogLoad, false);
