/* ***** BEGIN LICENSE BLOCK *****
 * Version: GPL 3.0
 *
 * The contents of this file are subject to the General Public License
 * 3.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.gnu.org/licenses/gpl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * -- Exchange 2007/2010 Calendar and Tasks Provider.
 * -- For Thunderbird with the Lightning add-on.
 *
 * This work is a combination of the Storage calendar, part of the default Lightning add-on, and 
 * the "Exchange Data Provider for Lightning" add-on currently, october 2011, maintained by Simon Schubert.
 * Primarily made because the "Exchange Data Provider for Lightning" add-on is a continuation 
 * of old code and this one is build up from the ground. It still uses some parts from the 
 * "Exchange Data Provider for Lightning" project.
 *
 * Author: Michel Verbraak (info@1st-setup.nl)
 * Website: http://www.1st-setup.nl/wordpress/?page_id=133
 * email: exchangecalendar@extensions.1st-setup.nl
 *
 *
 * This code uses parts of the Microsoft Exchange Calendar Provider code on which the
 * "Exchange Data Provider for Lightning" was based.
 * The Initial Developer of the Microsoft Exchange Calendar Provider Code is
 *   Andrea Bittau <a.bittau@cs.ucl.ac.uk>, University College London
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * ***** BEGIN LICENSE BLOCK *****/

var Cc = Components.classes;
var Ci = Components.interfaces;

var gexchWebServicesOldLocationTextBox = "";
var gexchWebServicesOldNextPage = "";
var gexchWebServicesOldCache = false;
var gexchWebServicesOldonpageadvanced = "";

var gexchWebServicesFirstTime = true;

var exchWebServicesCreateprefs = Cc["@mozilla.org/preferences-service;1"]
                    .getService(Ci.nsIPrefService)
		    .getBranch("extensions.exchangecalendar@extensions.1st-setup.nl.createcalendar.");

function exchWebServicesDoRadioExchangeCalendar(aRadioGroep)
{
	if (gexchWebServicesFirstTime) {
		// Get the next page to change how it should advance.
		var acustomizePage = document.getElementById('calendar-wizard').getPageById("customizePage");
		gexchWebServicesOldNextPage = acustomizePage.getAttribute("next");
		gexchWebServicesOldonpageadvanced = acustomizePage.getAttribute("onpageadvanced");

		gexchWebServicesFirstTime = false;		
	}

	if (aRadioGroep.value == "exchangecalendar") {
		gexchWebServicesOldLocationTextBox = document.getElementById("calendar-uri").value;
		gexchWebServicesOldCache = document.getElementById("cache").checked;

		document.getElementById("calendar-uri").value = "https://auto/"+cal.getUUID();
		document.getElementById("calendar-uri").parentNode.hidden = true;

		// Get the next page to set back new values.
		var acustomizePage = document.getElementById('calendar-wizard').getPageById("customizePage");
		acustomizePage.setAttribute( "next", "exchange1");
		acustomizePage.setAttribute( "onpageadvanced", "return true;");

		document.getElementById("cache").parentNode.hidden = true;
		document.getElementById("cache").checked = false;

	}
	else {
		document.getElementById("calendar-uri").value = gexchWebServicesOldLocationTextBox;
		document.getElementById("calendar-uri").parentNode.hidden = false;

		// Get the next page to set back  how it should advance.
		var acustomizePage = document.getElementById('calendar-wizard').getPageById("customizePage");
		acustomizePage.setAttribute( "next", gexchWebServicesOldNextPage);
		acustomizePage.setAttribute( "onpageadvanced", gexchWebServicesOldonpageadvanced);

		document.getElementById("cache").parentNode.hidden = false;
		document.getElementById("cache").checked = gexchWebServicesOldCache;
		
	}
	exchWebServicesCheckRequired();
}

function exchWebServicesInitExchange1()
{
	exchWebServicesCreateprefs.deleteBranch("");

	var selItem = document.getElementById("email-identity-menulist").selectedItem;
	if (selItem) {
		var identity = selItem.getAttribute("value");
		if (identity != "none") {
			var exchWebServicesIdentityprefs = Cc["@mozilla.org/preferences-service;1"]
	                    .getService(Ci.nsIPrefService)
			    .getBranch("mail.identity."+identity+".");

			document.getElementById("ecmailbox").value = exchWebServicesIdentityprefs.getCharPref("useremail");
			exchWebServicesInitMailbox(document.getElementById("ecmailbox").value);
			exchWebServicesCreateprefs.setCharPref("mailbox", document.getElementById("ecmailbox").value);
		}
		else {
			document.getElementById("ecmailbox").value = "";
		}
	}
	else {
		dump("no item selected\n");
	}


	document.getElementById("ecfolderpath").value = "/";

	exchWebServicesCheckRequired();
	
}

function exchWebServicesSaveSettings()
{
	exchWebServicesCreateprefs.setBoolPref("autodiscover", exchWebServicesgAutoDiscover);
	exchWebServicesCreateprefs.setCharPref("server", exchWebServicesgServer);
	exchWebServicesCreateprefs.setCharPref("mailbox", exchWebServicesgMailbox);
	exchWebServicesCreateprefs.setCharPref("displayname", exchWebServicesgDisplayName);
	exchWebServicesCreateprefs.setCharPref("user", exchWebServicesgUser);
	exchWebServicesCreateprefs.setCharPref("domain", exchWebServicesgDomain);
	exchWebServicesCreateprefs.setCharPref("folderbase", exchWebServicesgFolderBase);
	exchWebServicesCreateprefs.setCharPref("folderpath", exchWebServicesgFolderPath);
	
	if (exchWebServicesgFolderID != "") {
		exchWebServicesCreateprefs.setCharPref("folderID", exchWebServicesgFolderID);
	}
	if (exchWebServicesgChangeKey != "") {
		exchWebServicesCreateprefs.setCharPref("changeKey", exchWebServicesgChangeKey);
	}
	
	doCreateCalendar();
}

