/* ***** BEGIN LICENSE BLOCK *****
 * Version: GPL 3.0
 *
 * The contents of this file are subject to the General Public License
 * 3.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.gnu.org/licenses/gpl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * -- Exchange 2007/2010 Calendar and Tasks Provider.
 * -- For Thunderbird with the Lightning add-on.
 *
 * This work is a combination of the Storage calendar, part of the default Lightning add-on, and 
 * the "Exchange Data Provider for Lightning" add-on currently, october 2011, maintained by Simon Schubert.
 * Primarily made because the "Exchange Data Provider for Lightning" add-on is a continuation 
 * of old code and this one is build up from the ground. It still uses some parts from the 
 * "Exchange Data Provider for Lightning" project.
 *
 * Author: Michel Verbraak (info@1st-setup.nl)
 * Website: http://www.1st-setup.nl/wordpress/?page_id=133
 * email: exchangecalendar@extensions.1st-setup.nl
 *
 *
 * This code uses parts of the Microsoft Exchange Calendar Provider code on which the
 * "Exchange Data Provider for Lightning" was based.
 * The Initial Developer of the Microsoft Exchange Calendar Provider Code is
 *   Andrea Bittau <a.bittau@cs.ucl.ac.uk>, University College London
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * ***** BEGIN LICENSE BLOCK *****/

var Cc = Components.classes;
var Ci = Components.interfaces;
var Cu = Components.utils;

Cu.import("resource://gre/modules/XPCOMUtils.jsm");
Cu.import("resource://gre/modules/Services.jsm");

Cu.import("resource://calendar/modules/calUtils.jsm");

//Cu.import("resource://exchangecalendar/ecExchangeRequest.js");
Cu.import("resource://exchangecalendar/erAutoDiscover.js");
Cu.import("resource://exchangecalendar/erPrimarySMTPCheck.js");
Cu.import("resource://exchangecalendar/erFindFolder.js");
Cu.import("resource://exchangecalendar/erGetFolder.js");

Cu.import("resource://exchangecalendar/ecFunctions.js");

var gexchWebServicesDetailsChecked = false;
var gexchWebServices2ndDetailsChecked = true;

var exchWebServicesgAutoDiscover = false;
var exchWebServicesgServer = "";
var exchWebServicesgMailbox = "";
var exchWebServicesgDisplayName = "";
var exchWebServicesgUser = "";
var exchWebServicesgDomain = "";
var exchWebServicesgFolderBase = "calendar";
var exchWebServicesgFolderPath = "/";
var exchWebServicesgFolderID = "";
var exchWebServicesgChangeKey = "";

function exchWebServicesValidUsernameDomain()
{
	if ((document.getElementById("ecwindowsuser").value.indexOf("@") > -1) &&
		(document.getElementById("ecwindowsdomain").value == "")) {
		return true;
	}

	if ((document.getElementById("ecwindowsuser").value.indexOf("@") == -1) &&
		(document.getElementById("ecwindowsdomain").value != "")) {
		return true;
	}

	return false;
}

function exchWebServicesCheckRequired() {

	if (!gexchWebServicesDetailsChecked) {
		document.getElementById("ecfolderbaserow").hidden = true;
		document.getElementById("ecfolderpathrow").hidden = true;
	}

	if ((!gexchWebServices2ndDetailsChecked) || (!gexchWebServicesDetailsChecked)) {
		document.getElementById('ecdetailschecked').setAttribute("required", true);
	}
	else {
		document.getElementById('ecdetailschecked').setAttribute("required", false);
	}

	if (document.getElementById("ecautodiscover").checked) {

		exchWebServicesChangeFolderbaseMenuItemAvailability(false);

		document.getElementById("ecmailbox").setAttribute("required", true);
		document.getElementById("ecservercheckrow").hidden = true;

		if ( (document.getElementById("ecmailbox").value == "") ||
		     (!exchWebServicesValidUsernameDomain()) ) {
			document.getElementById("ecautodiscovercheckrow").hidden = true;
			document.getElementById("ecserverandmailboxcheckrow").hidden = true;
		}
		else {
			document.getElementById("ecautodiscovercheckrow").hidden = false;
			document.getElementById("ecserverandmailboxcheckrow").hidden = true;
		}
		document.getElementById("ecserver").disabled = true;
	}
	else {
		document.getElementById("ecmailbox").setAttribute("required", false);

		if (document.getElementById("ecmailbox").value == "") {

			if (document.getElementById("ecmailbox").value == "") {
				exchWebServicesChangeFolderbaseMenuItemAvailability(true);
				document.getElementById("menuitem.label.ecfolderbase.publicfoldersroot").disabled = false;
			}

			// No mailbox specified. We only do server check.
			if ( (document.getElementById("ecserver").value == "") ||
			     (!exchWebServicesValidUsernameDomain()) ) {
				document.getElementById("ecautodiscovercheckrow").hidden = true;
				document.getElementById("ecserverandmailboxcheckrow").hidden = true;
				document.getElementById("ecservercheckrow").hidden = true;
			}
			else {
				document.getElementById("ecautodiscovercheckrow").hidden = true;
				document.getElementById("ecserverandmailboxcheckrow").hidden = true;
				document.getElementById("ecservercheckrow").hidden = false;
			}
		}
		else {
			exchWebServicesChangeFolderbaseMenuItemAvailability(false);

			// No mailbox specified. We do server and mailbox check
			// No mailbox specified. We only do server check.
			if ( (document.getElementById("ecserver").value == "") ||
			     (!exchWebServicesValidUsernameDomain()) ) {
				document.getElementById("ecautodiscovercheckrow").hidden = true;
				document.getElementById("ecserverandmailboxcheckrow").hidden = true;
				document.getElementById("ecservercheckrow").hidden = true;
			}
			else {
				document.getElementById("ecautodiscovercheckrow").hidden = true;
				document.getElementById("ecserverandmailboxcheckrow").hidden = false;
				document.getElementById("ecservercheckrow").hidden = true;
			}
		}

		document.getElementById("ecserver").disabled = false;
	}
	
	if (gexchWebServicesDetailsChecked) {
		document.getElementById("ecautodiscovercheckrow").hidden = true;
		document.getElementById("ecserverandmailboxcheckrow").hidden = true;
		document.getElementById("ecservercheckrow").hidden = true;

		document.getElementById("ecfolderbaserow").hidden = false;
		document.getElementById("ecfolderpathrow").hidden = false;
	}

	checkRequired();
}

function exchWebServicesAutodiscoverCheckbox(aCheckBox)
{
	exchWebServicesgAutoDiscover = aCheckBox.checked;
	gexchWebServicesDetailsChecked = false;
	exchWebServicesCheckRequired();
}

function exchWebServicesInitMailbox(aNewValue)
{
	exchWebServicesgMailbox = aNewValue;
	gexchWebServicesDetailsChecked = false;
	exchWebServicesCheckRequired();
}

function exchWebServicesDoMailboxChanged(aTextBox)
{
	exchWebServicesgMailbox = aTextBox.value;
	document.getElementById("ecdisplayname").value = "";
	exchWebServicesgDisplayName = "";
	gexchWebServicesDetailsChecked = false;
	exchWebServicesCheckRequired();
}

function exchWebServicesDoUserChanged(aTextBox)
{
	exchWebServicesgUser = aTextBox.value;
	if (exchWebServicesgUser.indexOf("@") > -1) {
		document.getElementById("ecwindowsdomain").disabled = true;
		document.getElementById("ecwindowsdomain").value = "";
		document.getElementById("ecwindowsdomain").setAttribute("required", false);
		exchWebServicesgDomain = "";
	}
	else {
		document.getElementById("ecwindowsdomain").disabled = false;
		document.getElementById("ecwindowsdomain").setAttribute("required", true);
	}

	gexchWebServicesDetailsChecked = false;
	exchWebServicesCheckRequired();
}

function exchWebServicesDoDomainChanged(aTextBox)
{
	exchWebServicesgDomain = aTextBox.value;
	gexchWebServicesDetailsChecked = false;
	exchWebServicesCheckRequired();
}

function exchWebServicesDoServerChanged(aTextBox)
{
	exchWebServicesgServer = aTextBox.value;
	gexchWebServicesDetailsChecked = false;
	exchWebServicesCheckRequired();
}

// newStatus = true will disable folderbase menuitems
// newStatus = false will enable all folderbase menuitems

function exchWebServicesChangeFolderbaseMenuItemAvailability(newStatus)
{
	var menuItem = document.getElementById("menupopup.ecfolderbase").firstChild;
	while (menuItem) {
		if (! menuItem.hasAttribute("donotchange")) {
			menuItem.disabled = newStatus;
		}
		menuItem = menuItem.nextSibling;
	}
	
}

function exchWebServicesDoFolderBaseChanged(aMenuList)
{
	exchWebServicesgFolderBase = aMenuList.value;

	// Reset folder path
	document.getElementById("ecfolderpath").value = "/";
	exchWebServicesgFolderPath = "/";

	exchWebServicesgFolderID = "";
	exchWebServicesgChangeKey = "";

	if (document.getElementById("ecfolderpath").value != "/") {
		gexchWebServices2ndDetailsChecked = false;
	}
	else {
		gexchWebServices2ndDetailsChecked = true;
	}
	exchWebServicesCheckRequired();
}

function exchWebServicesGetUsername()
{
	if (exchWebServicesgUser.indexOf("@") > -1) {
		return exchWebServicesgUser;
	}
	else {
		return exchWebServicesgDomain+"\\"+exchWebServicesgUser;
	}
}

function exchWebServicesDoCheckServerAndMailbox()
{
	document.getElementById("ecserverandmailboxcheckbutton").disabled = true;

	
	try {
	var tmpObject = new erPrimarySMTPCheckRequest(
		{user: exchWebServicesGetUsername(), 
		 mailbox: exchWebServicesgMailbox,
		 serverUrl: exchWebServicesgServer}, exchWebServicesCheckServerAndMailboxOK, exchWebServicesCheckServerAndMailboxError)
	}
	catch(err) {
		cal.ERROR("Warning: Error during creation of erPrimarySMTPCheckRequest. Err="+err+"\n");
	}
}

function exchWebServicesCheckServerAndMailboxOK(newPrimarySMTP)
{

	if (newPrimarySMTP) {
		exchWebServicesgMailbox = newPrimarySMTP
		document.getElementById("ecmailbox").value = newPrimarySMTP;
	}

	gexchWebServicesDetailsChecked = true;
	document.getElementById("ecserverandmailboxcheckbutton").disabled = false;

	exchWebServicesCheckRequired();
}

function exchWebServicesCheckServerAndMailboxError(aExchangeRequest, aCode, aMsg)
{
	gexchWebServicesDetailsChecked = false;
	switch (aCode) {
	case -20:
		break;
	case -6:
		alert(cal.calGetString("calExchangeCalendar", "ecErrorServerCheckURLInvalid", [exchWebServicesgServer], "exchangecalendar"));
		break;
	default:
		alert(cal.calGetString("calExchangeCalendar", "ecErrorServerAndMailboxCheck", [aMsg, aCode], "exchangecalendar"));
	}
	document.getElementById("ecserverandmailboxcheckbutton").disabled = false;
	exchWebServicesCheckRequired();
}

function exchWebServicesDoCheckServer()
{
	document.getElementById("ecservercheckbutton").disabled = true;

	
	try {
	var tmpObject = new erGetFolderRequest(
		{user: exchWebServicesGetUsername(), 
		 mailbox: "",
		 folderBase: "publicfoldersroot",
		 folderPath: "/",
		 serverUrl: exchWebServicesgServer}, exchWebServicesCheckServerOK, exchWebServicesCheckServerError)
	}
	catch(err) {
		cal.ERROR("Warning: Error during creation of erGetFolderRequest. Err="+err+"\n");
	}
}

function exchWebServicesCheckServerOK( folderID, changeKey, folderClass)
{

	gexchWebServicesDetailsChecked = true;
	document.getElementById("ecservercheckbutton").disabled = false;
//	exchWebServicesChangeFolderbaseMenuItemAvailability(true);
//	document.getElementById("menuitem.label.ecfolderbase.publicfoldersroot").disabled = false;

	if (exchWebServicesgFolderBase != "publicfoldersroot") {
		exchWebServicesgFolderBase = "publicfoldersroot";
		document.getElementById("ecfolderbase").value = "publicfoldersroot";
		document.getElementById("ecfolderpath").value = "/";
	}

	exchWebServicesCheckRequired();
}

function exchWebServicesCheckServerError(aExchangeRequest, aCode, aMsg)
{
	gexchWebServicesDetailsChecked = false;
	switch (aCode) {
	case -20:
		break;
	case -6:
		alert(cal.calGetString("calExchangeCalendar", "ecErrorServerCheckURLInvalid", [exchWebServicesgServer], "exchangecalendar"));
		break;
	default:
		alert(cal.calGetString("calExchangeCalendar", "ecErrorServerCheck", [aMsg, aCode], "exchangecalendar"));
	}
	document.getElementById("ecservercheckbutton").disabled = false;

//	exchWebServicesChangeFolderbaseMenuItemAvailability(false);

	exchWebServicesCheckRequired();
}

function exchWebServicesDoAutodiscoverCheck()
{
	document.getElementById("ecautodiscovercheckbutton").disabled = true;

	try {
	var tmpObject = new erAutoDiscoverRequest( 
		{user: exchWebServicesGetUsername(), 
		 mailbox: exchWebServicesgMailbox}, 
		 exchWebServicesAutodiscoveryOK, 
		 exchWebServicesAutodiscoveryError, null)
	}
	catch(err) {
		cal.ERROR("Warning: Could not create erAutoDiscoverRequest. Err="+err+"\n");
	}
}

function exchWebServicesAutodiscoveryOK(ewsUrls, DisplayName, SMTPAddress)
{
	ews.LOG("ecAutodiscoveryOK");
	var selectedEWSUrl = {value:undefined};
	var userCancel = false;

	if (ewsUrls) {
		if (ewsUrls.length() > 1) {
			// We have got multiple ews urls returned. Let the use choose.

			window.openDialog("chrome://exchangecalendar/content/selectEWSUrl.xul",
				"selectfrommultipleews",
				"chrome,titlebar,toolbar,centerscreen,dialog,modal=yes,resizable=no",
				ewsUrls, selectedEWSUrl); 

			if (selectedEWSUrl.value == "") {
				userCancel = true;
			}
		}
		else {
			// We only have one url. Use it.
			selectedEWSUrl.value = ewsUrls.text();
		}

	}

	if (!userCancel) {
		exchWebServicesgDisplayName = DisplayName;
		document.getElementById("ecdisplayname").value = DisplayName;

		if ((SMTPAddress) && (SMTPAddress != '')) {
			exchWebServicesgMailbox = SMTPAddress;
			document.getElementById("ecmailbox").value = SMTPAddress;
		}
	
		exchWebServicesgServer = selectedEWSUrl.value;
		document.getElementById("ecserver").value = selectedEWSUrl.value; 

		gexchWebServicesDetailsChecked = true;
	}

	document.getElementById("ecautodiscovercheckbutton").disabled = false;
	document.getElementById("ecautodiscover").checked = false;
	exchWebServicesCheckRequired();
}

function exchWebServicesAutodiscoveryError(aExchangeRequest, aCode, aMsg)
{
	ews.LOG("ecAutodiscoveryError. aCode:"+aCode+", aMsg:"+aMsg);
	switch (aCode) {
	case -20:
		break;
	case -6:
		alert(cal.calGetString("calExchangeCalendar", "ecErrorAutodiscoveryURLInvalid", [exchWebServicesgMailbox], "exchangecalendar"));
		break;
	default:
		alert(cal.calGetString("calExchangeCalendar", "ecErrorAutodiscovery", [aMsg, aCode], "exchangecalendar"));
	}

	document.getElementById("ecautodiscovercheckbutton").disabled = false;
	exchWebServicesCheckRequired();
}

function exchWebServicesLoadExchangeSettingsByCalId(aCalId)
{
	var exchWebServicesCalPrefs = Cc["@mozilla.org/preferences-service;1"]
                    .getService(Ci.nsIPrefService)
		    .getBranch("extensions.exchangecalendar@extensions.1st-setup.nl."+aCalId+".");

	if (exchWebServicesCalPrefs) {
		document.getElementById("ecserver").value = exchWebServicesCalPrefs.getCharPref("ecServer");
		document.getElementById("ecwindowsuser").value = exchWebServicesCalPrefs.getCharPref("ecUser");
		if (document.getElementById("ecwindowsuser").value.indexOf("@") > -1) {
			document.getElementById("ecwindowsdomain").setAttribute("required", false);
			document.getElementById("ecwindowsdomain").disabled = true;
		}
		document.getElementById("ecwindowsdomain").value = exchWebServicesCalPrefs.getCharPref("ecDomain");
		document.getElementById("ecfolderpath").value = exchWebServicesCalPrefs.getCharPref("ecFolderpath");

		for (var i=0; i < document.getElementById("ecfolderbase").itemCount; i++) {
			if (document.getElementById("ecfolderbase").getItemAtIndex(i).value == exchWebServicesCalPrefs.getCharPref("ecFolderbase")) {
				document.getElementById("ecfolderbase").selectedIndex = i;
			}
		}
		document.getElementById("ecmailbox").value = exchWebServicesCalPrefs.getCharPref("ecMailbox");
		if (document.getElementById("ecmailbox").value == "") {
			exchWebServicesChangeFolderbaseMenuItemAvailability(true);
			document.getElementById("menuitem.label.ecfolderbase.publicfoldersroot").disabled = false;
		}


		exchWebServicesgServer = exchWebServicesCalPrefs.getCharPref("ecServer");
		exchWebServicesgUser = exchWebServicesCalPrefs.getCharPref("ecUser");
		exchWebServicesgDomain = exchWebServicesCalPrefs.getCharPref("ecDomain");

		exchWebServicesgFolderBase = exchWebServicesCalPrefs.getCharPref("ecFolderbase");
		exchWebServicesgFolderPath = exchWebServicesCalPrefs.getCharPref("ecFolderpath");
		exchWebServicesgMailbox = exchWebServicesCalPrefs.getCharPref("ecMailbox");
		try {
			exchWebServicesgFolderID = exchWebServicesCalPrefs.getCharPref("ecFolderID");
		} catch(err) { exchWebServicesgFolderID = ""; }
		try {
			exchWebServicesgChangeKey = exchWebServicesCalPrefs.getCharPref("ecChangeKey");
		} catch(err) { exchWebServicesgChangeKey = ""; }
	}

	gexchWebServicesDetailsChecked = true;
	gexchWebServices2ndDetailsChecked = true;

	exchWebServicesCheckRequired();
}

function exchWebServicesSaveExchangeSettingsByCalId(aCalId)
{
	var exchWebServicesCalPrefs = Cc["@mozilla.org/preferences-service;1"]
                    .getService(Ci.nsIPrefService)
		    .getBranch("extensions.exchangecalendar@extensions.1st-setup.nl."+aCalId+".");

	if (exchWebServicesCalPrefs) {
		exchWebServicesCalPrefs.setCharPref("ecServer", exchWebServicesgServer);
		exchWebServicesCalPrefs.setCharPref("ecUser", exchWebServicesgUser);
		exchWebServicesCalPrefs.setCharPref("ecDomain", exchWebServicesgDomain);
		exchWebServicesCalPrefs.setCharPref("ecFolderpath", exchWebServicesgFolderPath);
		exchWebServicesCalPrefs.setCharPref("ecFolderbase", exchWebServicesgFolderBase);
		exchWebServicesCalPrefs.setCharPref("ecMailbox", exchWebServicesgMailbox);
	}

	if (exchWebServicesgFolderPath == "/") {
		exchWebServicesgFolderID = "";
		exchWebServicesgChangeKey = "";
	}
	exchWebServicesCalPrefs.setCharPref("ecFolderID", exchWebServicesgFolderID);
	exchWebServicesCalPrefs.setCharPref("ecChangeKey", exchWebServicesgChangeKey);
}

function exchWebServicesDoFolderBrowse()
{
	var input = { answer: "",
			parentFolder: {user: exchWebServicesGetUsername(), 
					mailbox: exchWebServicesgMailbox,
					folderBase: exchWebServicesgFolderBase,
					serverUrl: exchWebServicesgServer,
					folderID: null,
					changeKey: null} 
			};

	window.openDialog("chrome://exchangecalendar/content/browseFolder.xul",
			"browseFolder",
			"chrome,titlebar,toolbar,centerscreen,dialog,modal=yes,resizable=no",
			input); 

	if (input.answer == "select") {
		document.getElementById("ecfolderpath").value = input.fullPath;
		exchWebServicesgFolderPath = input.fullPath;

		gexchWebServices2ndDetailsChecked = true;

		if (input.fullPath == "/") {
			exchWebServicesgFolderID = "";
			exchWebServicesgChangeKey = "";
		}
		else {
			exchWebServicesgFolderID = input.selectedFolder.folderID;
			exchWebServicesgChangeKey = input.selectedFolder.changeKey;
		}
		exchWebServicesCheckRequired();
	}
}
