/* ***** BEGIN LICENSE BLOCK *****
 * Version: GPL 3.0
 *
 * The contents of this file are subject to the General Public License
 * 3.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.gnu.org/licenses/gpl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * -- Exchange 2007/2010 Calendar and Tasks Provider.
 * -- For Thunderbird with the Lightning add-on.
 *
 * This work is a combination of the Storage calendar, part of the default Lightning add-on, and 
 * the "Exchange Data Provider for Lightning" add-on currently, october 2011, maintained by Simon Schubert.
 * Primarily made because the "Exchange Data Provider for Lightning" add-on is a continuation 
 * of old code and this one is build up from the ground. It still uses some parts from the 
 * "Exchange Data Provider for Lightning" project.
 *
 * Author: Michel Verbraak (info@1st-setup.nl)
 * Website: http://www.1st-setup.nl/wordpress/?page_id=133
 * email: exchangecalendar@extensions.1st-setup.nl
 *
 *
 * This code uses parts of the Microsoft Exchange Calendar Provider code on which the
 * "Exchange Data Provider for Lightning" was based.
 * The Initial Developer of the Microsoft Exchange Calendar Provider Code is
 *   Andrea Bittau <a.bittau@cs.ucl.ac.uk>, University College London
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * ***** BEGIN LICENSE BLOCK *****/

var Cc = Components.classes;
var Ci = Components.interfaces;
var Cu = Components.utils;


Cu.import("resource://calendar/modules/calUtils.jsm");
Cu.import("resource://exchangecalendar/erGetUserOofSettings.js");
Cu.import("resource://exchangecalendar/erSetUserOofSettings.js");
Cu.import("resource://exchangecalendar/ecFunctions.js");




var exchWebServicesCalPrefs;
var exchWebServicesOofSettings;

function exchWebServicesOnLoad()
{
	var calId = window.arguments[0].calendar.id;

	exchWebServicesCalPrefs = Cc["@mozilla.org/preferences-service;1"]
                    .getService(Ci.nsIPrefService)
		    .getBranch("extensions.exchangecalendar@extensions.1st-setup.nl."+calId+".");

	document.getElementById("ecOofSettings-title").value = ews.safeGetCharPref(exchWebServicesCalPrefs, "ecMailbox", "null");

	EditorOnLoad();

	exchWebServicesGetOofSettings();
}

function exchWebServicesOnSave()
{
	exchWebServicesSetOofSettings();

	return false;
}

function exchWebServicesGetOofSettings()
{
	document.getElementById("load-error-message").value = cal.calGetString("calExchangeCalendar", "ecLoadingOofSettings", [], "exchangecalendar");

	var tmpObject = new erGetUserOofSettingsRequest(
		{user: ews.safeGetCharPref(exchWebServicesCalPrefs, "ecDomain", "null")+"\\"+ews.safeGetCharPref(exchWebServicesCalPrefs, "ecUser", "null"), 
		 mailbox: ews.safeGetCharPref(exchWebServicesCalPrefs, "ecMailbox", "null"),
		 serverUrl: ews.safeGetCharPref(exchWebServicesCalPrefs, "ecServer", "null")}, exchWebServicesGetOofSettingsOK, exchWebServicesGetOofSettingsError)
}

function exchWebServicesGetOofSettingsOK(aGetUserOofSettingsRequest, aOofSettings)
{
	exchWebServicesOofSettings = aOofSettings;

	ews.LOG("intern:"+aOofSettings.internalReply);
	ews.LOG("extern:"+aOofSettings.externalReply);

	document.getElementById("load-error-message").value = cal.calGetString("calExchangeCalendar", "ecLoadedOofSettings", [], "exchangecalendar");	
	
	document.getElementById("ecOofSettings").buttons = "accept,cancel";

	document.getElementById("vbox-oof-settings").disabled = false;

	document.getElementById("ec-oof-status").value = (aOofSettings.oofState == "Disabled") ? "Disabled" : "Enabled";

	document.getElementById("ec-oof-scheduled").checked = (aOofSettings.oofState == "Scheduled");

	if (aOofSettings.startTime) {
		document.getElementById("ec-oof-startdate").year = aOofSettings.startTime.year;
		document.getElementById("ec-oof-startdate").month = aOofSettings.startTime.month;
		document.getElementById("ec-oof-startdate").date = aOofSettings.startTime.day;

		document.getElementById("ec-oof-starttime").hour = aOofSettings.startTime.hour;
		document.getElementById("ec-oof-starttime").minute = aOofSettings.startTime.minute;
	}

	if (aOofSettings.endTime) {
		document.getElementById("ec-oof-enddate").year = aOofSettings.endTime.year;
		document.getElementById("ec-oof-enddate").month = aOofSettings.endTime.month;
		document.getElementById("ec-oof-enddate").date = aOofSettings.endTime.day;

		document.getElementById("ec-oof-endtime").hour = aOofSettings.endTime.hour;
		document.getElementById("ec-oof-endtime").minute = aOofSettings.endTime.minute;
	}

	exchWebServicesDoScheduledChanged();


	document.getElementById("ec-oof-externalaudience").value = aOofSettings.externalAudience;

	var editorElement = document.getElementById("content-frame");
	if (!document.getElementById("ec-oof-button-internal").disabled) {
		editorElement.contentDocument.documentElement.innerHTML = exchWebServicesHTMLParser2(exchWebServicesOofSettings.internalReply);
	}
	else {
		editorElement.contentDocument.documentElement.innerHTML = exchWebServicesHTMLParser2(exchWebServicesOofSettings.externalReply);
	}


//	document.getElementById("ec-oof-internalreply").value = aOofSettings.internalReply;
//	document.getElementById("ec-oof-externalreply").value = aOofSettings.externalReply;
	document.getElementById("ec-oof-externalreply").innerHTML = "Voorbeeld";

      //SetupHTMLEditorCommands();
}

function exchWebServicesGetOofSettingsError(aGetUserOofSettingsRequest, aCode, aMsg)
{
	document.getElementById("load-error-message").value = cal.calGetString("calExchangeCalendar", "ecErrorLoadingOofSettings", [aMsg, aCode], "exchangecalendar");
}

function exchWebServicesDoScheduledChanged()
{
	// Enable or disable time/date pickers
	document.getElementById("ec-oof-startdate").disabled = (!document.getElementById("ec-oof-scheduled").checked);
	document.getElementById("ec-oof-starttime").disabled = (!document.getElementById("ec-oof-scheduled").checked);
	document.getElementById("ec-oof-enddate").disabled = (!document.getElementById("ec-oof-scheduled").checked);
	document.getElementById("ec-oof-endtime").disabled = (!document.getElementById("ec-oof-scheduled").checked);
}

function exchWebServicesHTMLParser2(aHTMLString){
	var tmpStr = aHTMLString;

	// Strip everything up to <body>
	var index1 = tmpStr.toLowerCase().indexOf("<body>");
	if (index1 > -1) {
		tmpStr = tmpStr.substr(index1+6);
	}


	// Strip everything after </body> including the closing body tag.
	index1 = tmpStr.toLowerCase().indexOf("</body>");
	if (index1 > -1) {
		tmpStr = tmpStr.substr(0, index1);
	}

	return tmpStr;
}


function exchWebServicesDoButtonPressed(aButton)
{
	aButton.disabled = true;
	if (aButton.id == "ec-oof-button-internal") {
		document.getElementById("ec-oof-button-external").disabled = false;

		document.getElementById("ec-oof-label-internal").hidden = true;
		document.getElementById("ec-oof-label-external").hidden = false;

		var editorElement = document.getElementById("content-frame");
		// Save internalReply for later usage.
		exchWebServicesOofSettings.internalReply = editorElement.contentDocument.documentElement.innerHTML;
		editorElement.contentDocument.documentElement.innerHTML = exchWebServicesHTMLParser2(exchWebServicesOofSettings.externalReply);
	}
	else {
		document.getElementById("ec-oof-button-internal").disabled = false;

		document.getElementById("ec-oof-label-internal").hidden = false;
		document.getElementById("ec-oof-label-external").hidden = true;

		var editorElement = document.getElementById("content-frame");
		// Save externalReply for later usage.
		exchWebServicesOofSettings.externalReply = editorElement.contentDocument.documentElement.innerHTML;
		editorElement.contentDocument.documentElement.innerHTML = exchWebServicesHTMLParser2(exchWebServicesOofSettings.internalReply);
	}
}

function exchWebServicesSetOofSettings()
{
	document.getElementById("load-error-message").value = cal.calGetString("calExchangeCalendar", "ecSavingOofSettings", [], "exchangecalendar");

	var oofState = "Disabled";
	if (document.getElementById("ec-oof-status").value == "Enabled") {
		oofState = "Enabled";
		if (document.getElementById("ec-oof-scheduled").checked) {
			oofState = "Scheduled";
		}
	}
 
	var startTime = cal.createDateTime();
	startTime.resetTo(document.getElementById("ec-oof-startdate").year,
			document.getElementById("ec-oof-startdate").month,
			document.getElementById("ec-oof-startdate").date,
			document.getElementById("ec-oof-starttime").hour,
			document.getElementById("ec-oof-starttime").minute,
			0,
			ews.ecDefaultTimeZone());
	startTime = startTime.getInTimezone(ews.ecUTC());

	var endTime = cal.createDateTime();
	endTime.resetTo(document.getElementById("ec-oof-enddate").year,
			document.getElementById("ec-oof-enddate").month,
			document.getElementById("ec-oof-enddate").date,
			document.getElementById("ec-oof-endtime").hour,
			document.getElementById("ec-oof-endtime").minute,
			0,
			ews.ecDefaultTimeZone());
	endTime = endTime.getInTimezone(ews.ecUTC());

	var internalReply = exchWebServicesOofSettings.internalReply;
	var externalReply = exchWebServicesOofSettings.externalReply;
	if (!document.getElementById("ec-oof-button-internal").disabled) {
		var editorElement = document.getElementById("content-frame");
		internalReply = editorElement.contentDocument.documentElement.innerHTML;
	}
	if (!document.getElementById("ec-oof-button-external").disabled) {
		var editorElement = document.getElementById("content-frame");
		externalReply = editorElement.contentDocument.documentElement.innerHTML;
	}

	var tmpObject = new erSetUserOofSettingsRequest(
		{user: ews.safeGetCharPref(exchWebServicesCalPrefs, "ecDomain", "null")+"\\"+ews.safeGetCharPref(exchWebServicesCalPrefs, "ecUser", "null"), 
		 mailbox: ews.safeGetCharPref(exchWebServicesCalPrefs, "ecMailbox", "null"),
		 serverUrl: ews.safeGetCharPref(exchWebServicesCalPrefs, "ecServer", "null"),
		
		 oofState : oofState,
		 externalAudience : document.getElementById("ec-oof-externalaudience").value,
		 startTime : startTime,
		 endTime : endTime,
		 internalReply : internalReply,
		 externalReply : externalReply

		}, exchWebServicesSetOofSettingsOK, exchWebServicesSetOofSettingsError);
}

function exchWebServicesSetOofSettingsOK(aGetUserOofSettingsRequest)
{
	document.getElementById("load-error-message").value = cal.calGetString("calExchangeCalendar", "ecSavedOofSettings", [], "exchangecalendar");
	alert("Settings saved.");

	exchWebServicesGetOofSettings();

}

function exchWebServicesSetOofSettingsError(aGetUserOofSettingsRequest, aCode, aMsg)
{
	document.getElementById("load-error-message").value = cal.calGetString("calExchangeCalendar", "ecErrorSavingOofSettings", [aMsg, aCode], "exchangecalendar");
	alert("Error saving settings. Msg:"+aMsg+", Code:"+aCode);

	exchWebServicesGetOofSettings();

}


