/* ***** BEGIN LICENSE BLOCK *****
 * Version: GPL 3.0
 *
 * The contents of this file are subject to the General Public License
 * 3.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.gnu.org/licenses/gpl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * -- Exchange 2007/2010 Calendar and Tasks Provider.
 * -- For Thunderbird with the Lightning add-on.
 *
 * This work is a combination of the Storage calendar, part of the default Lightning add-on, and 
 * the "Exchange Data Provider for Lightning" add-on currently, october 2011, maintained by Simon Schubert.
 * Primarily made because the "Exchange Data Provider for Lightning" add-on is a continuation 
 * of old code and this one is build up from the ground. It still uses some parts from the 
 * "Exchange Data Provider for Lightning" project.
 *
 * Author: Michel Verbraak (info@1st-setup.nl)
 * Website: http://www.1st-setup.nl/wordpress/?page_id=133
 * email: exchangecalendar@extensions.1st-setup.nl
 *
 *
 *
 * ***** BEGIN LICENSE BLOCK *****/

var Cc = Components.classes;
var Ci = Components.interfaces;
var Cu = Components.utils;
var Cr = Components.results;
var components = Components;
Cu.import("resource://gre/modules/XPCOMUtils.jsm");
Cu.import("resource://gre/modules/Services.jsm");

Cu.import("resource://calendar/modules/calUtils.jsm");

Cu.import("resource://exchangecalendar/ecFunctions.js");

/**
 * Constructor of ecItipExchangeTransport object
 */
var EXPORTED_SYMBOLS = ["ecItipExchangeTransport"];

function ecItipExchangeTransport() {
    this.wrappedJSObject = this;
    ews.LOG("ecItipExchangeTransport Constructor");
}

ecItipExchangeTransport.prototype = {
    classID: Components.ID("{b9b58426-2597-11e1-a95f-e2904824019b}"),
    contractID: "@mozilla.org/calendar/itip-transport;1?type=exchangecalendar",
    classDescription: "Calendar iTIP Exchange Transport",

    getInterfaces: function getInterfaces(count) {
        const ifaces = [Components.interfaces.calIItipTransport,
                        Components.interfaces.nsIClassInfo,
                        Components.interfaces.nsISupports];
        count.value = ifaces.length;
        return ifaces;
    },
    getHelperForLanguage: function _getHelperForLanguage(language) {
        return null;
    },
    implementationLanguage: Components.interfaces.nsIProgrammingLanguage.JAVASCRIPT,
    flags: 0,

    QueryInterface: function QueryInterface(aIID) {
        return cal.doQueryInterface(this, ecItipExchangeTransport.prototype, aIID, null, this);
    },

    get scheme() {
           ews.LOG("ecItipExchangeTransport: scheme()...");
        return "exchangecalendar";
    },

    mSenderAddress: null,
    get senderAddress() {
           ews.LOG("ecItipExchangeTransport: get senderAddress()");
        return this.mSenderAddress;
    },
    set senderAddress(aValue) {
           ews.LOG("ecItipExchangeTransport: set senderAddress("+aValue+")");
        return (this.mSenderAddress = aValue);
    },

    get type() {
           ews.LOG("ecItipExchangeTransport: type()...");
        return "exchangecalendar";
    },

    sendItems: function _sendItems(aCount, aRecipients, aItipItem) {
//        if (this.mHasXpcomMail) {
            ews.LOG("ecItipExchangeTransport: sendItems: Sending Email...");

            let item = aItipItem.getItemList({})[0];

            // Get ourselves some default text - when we handle organizer properly
            // We'll need a way to configure the Common Name attribute and we should
            // use it here rather than the email address

/*            let summary = (item.getProperty("SUMMARY") || "");
            let aSubject = "";
            let aBody = "";
            switch (aItipItem.responseMethod) {
                case 'REQUEST':
                    aSubject = cal.calGetString("lightning",
                                                "itipRequestSubject",
                                                [summary],
                                                "lightning");
                    aBody = cal.calGetString("lightning",
                                             "itipRequestBody",
                                             [item.organizer ? item.organizer.toString() : "", summary],
                                             "lightning");
                    break;
                case 'CANCEL':
                    aSubject = cal.calGetString("lightning",
                                                "itipCancelSubject",
                                                [summary],
                                                "lightning");
                    aBody = cal.calGetString("lightning",
                                             "itipCancelBody",
                                             [item.organizer ? item.organizer.toString() : "", summary],
                                             "lightning");
                    break;
                case 'REPLY': {
                    // Get my participation status
                    let att = (cal.calInstanceOf(aItipItem.targetCalendar, Components.interfaces.calISchedulingSupport)
                               ? aItipItem.targetCalendar.getInvitedAttendee(item) : null);
                    if (!att && aItipItem.identity) {
                        att = item.getAttendeeById("mailto:" + aItipItem.identity);
                    }
                    if (!att) { // should not happen anymore
                        return;
                    }

                    // work around BUG 351589, the below just removes RSVP:
                    aItipItem.setAttendeeStatus(att.id, att.participationStatus);
                    let myPartStat = att.participationStatus;
                    let name = att.toString();

                    // Generate proper body from my participation status
                    aSubject = cal.calGetString("lightning",
                                                "itipReplySubject",
                                                [summary],
                                                "lightning");
                    aBody = cal.calGetString("lightning",
                                             (myPartStat == "DECLINED") ? "itipReplyBodyDecline"
                                                                        : "itipReplyBodyAccept",
                                             [name],
                                             "lightning");
                    break;
                }
            }

            this._sendXpcomMail(aRecipients, aSubject, aBody, aItipItem);
        } else {
            // Sunbird case: Call user's default mailer on system.
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
        } */
    },

};

function NSGetFactory(cid) {

	ews.LOG("--XX itip--1");
	try {
		if (!NSGetFactory.ecItip) {
			NSGetFactory.ecItip = XPCOMUtils.generateNSGetFactory([ecItipExchangeTransport]);
		}
	} catch(e) {
		Components.utils.reportError(e);
		dump(e);
		throw e;
	}

	ews.LOG("---XX itip--miv");
	return NSGetFactory.ecItip(cid);
}

